(**
   {ɦW :  Dates.pas
   {ت:
          ŧit@ class NewDate ,swqfunction  GetText
           overload [ (SetValue)
          function GetText: string;  //Ǧ^  ^大 
          procedure SetValue (m, d, y: Integer);overload;
          procedure SetValue (par_date:TDatetime);overload;


   [c:
          Date class

     private                                                |
         Month, Day, Year: Integer;                         |
                                                            | ------->  Other Unit
     public (method)                                        |
       constructor Init (m, d, y: Integer);                 | <-------  Other Object
       procedure SetValue (m, d, y: Integer);overload;      |
       procedure SetValue (par_date:TDatetime);overload;    |
       function LeapYear: Boolean;                          |
       function GetText: string; // 05.02.2002          |
       ..                                                   |
     protected                                              |
       function DaysInMonth: Integer;  //Ӥ@X       |
                                                            |
                                                            |
                                                            |
   {descendant class}
   NewDate = class (Date)
   public
     function GetText: string;
   end;


**)

unit Dates;

interface
uses sysutils;

type
  Date = class
  private
    Month, Day, Year: Integer;
  public
    constructor Init (m, d, y: Integer);
    procedure SetValue (m, d, y: Integer);overload;
    procedure SetValue (par_Date:TDatetime);overload;
    function LeapYear: Boolean;
    procedure Increase;
    procedure Decrease;
    procedure Add (NumberOfDays: Integer);
    procedure Subtract (NumberOfDays: Integer);
    function GetText: string;
  protected
    function DaysInMonth: Integer;
  end;

  {descendant class}
  NewDate = class (Date)
  public
    function GetText: string;
  end;

implementation


{definition of the months names}
const
  MonthNames: array [1..12] of string =
    ('January', 'February', 'March', 'April', 'May', 'June',
    'July', 'August', 'September', 'October', 'November', 'December');

{method of the descendant class}
function NewDate.GetText: string;
begin
  {again some strange formatting code}
  GetText :=  Format ('%s %d, %d', [MonthNames[Month], Day, Year]);
end;

constructor Date.Init (m, d, y: Integer);
begin
  Month := m;
  Day := d;
  Year := y;
end;

procedure Date.SetValue (m, d, y: Integer);
begin
  Month := m;
  Day := d;
  Year := y;
end;

procedure Date.SetValue(par_Date:TDatetime);
var
  Tmp_Year,Tmp_Month,Tmp_Day:Word;
begin
  //DecodeDate(par_date,Year,Month,Day);
  DecodeDate(par_date,Tmp_Year,Tmp_Month,Tmp_Day);
  Year:=Tmp_Year;
  Month:=Tmp_Month;
  Day:=Tmp_Day;
end;


function Date.LeapYear: Boolean;
begin
  {compute leap years, considering "exceptions"}
  if (Year mod 4 <> 0) then
    LeapYear := False
  else
    if (Year mod 100 <> 0) then
      LeapYear := True
    else
    if (Year mod 400 <> 0) then
      LeapYear := False
    else
      LeapYear := True;
end;

function Date.DaysInMonth: Integer;
begin
  case Month of
    1, 3, 5, 7, 8, 10, 12:
      DaysInMOnth := 31;
    4, 6, 9, 11:
      DaysInMonth := 30;
    2:
      if (LeapYear) then
        DaysInMonth := 29
      else
        DaysInMonth := 28;
    else
      // if the month is not correct
      DaysInMonth := 0;
  end;
end;

procedure Date.Increase;
begin
  {if this day is not the last of the month}
  if (Day < DaysInMonth) then
    Inc (Day)  {increase the value by 1}
  else
  {if it is not in December}
    if (Month < 12) then
      begin
        {Day 1 of next month}
        Inc (Month);
        Day := 1;
      end
    else
      begin
        {else it is next year New Year's Day}
        Inc (Year);
        Month := 1;
        Day := 1;
      end;
end;

procedure Date.Decrease;
{exactly the reverse of the Increase method}
begin
  if (Day > 1) then
    Dec (Day)  {decrease the value by 1}
  else
  {it is the first of a month}
    if (Month > 1) then
      begin
        {assign last day of previous month}
        Dec (Month);
        Day := DaysInMOnth;
      end
    else
    {it is the first of January}
      begin
        {assign last day of previous year}
        Dec (Year);
        Month := 12;
        Day := DaysInMOnth;
      end;
end;

function Date.GetText: string;
begin
  {format the text, converting the integers to
  strings with a fixed number of characters}
  GetText := Format ('%.2d.%.2d.%4d', [Month, Day, Year]);
end;

procedure Date.Add (NumberOfDays: Integer);
var
  n: Integer;
begin
  {increase the day n times}
  for n:=1 to NumberOfDays do
    Increase;
end;

procedure Date.Subtract (NumberOfDays: Integer);
var
  n: Integer;
begin
  {decrease the day n times}
  for n:=1 to NumberOfDays do
    Decrease;
end;

end.

